diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/propagation/bindings/modulegen__gcc_LP64.py ns-3.33/src/propagation/bindings/modulegen__gcc_LP64.py
--- ns-3.32/src/propagation/bindings/modulegen__gcc_LP64.py	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/propagation/bindings/modulegen__gcc_LP64.py	2021-01-09 10:19:22.000000000 -0800
@@ -3465,7 +3608,22 @@
     cls.add_method('ComputePlos', 
                    'double', 
                    [param('ns3::Ptr< ns3::MobilityModel const >', 'a'), param('ns3::Ptr< ns3::MobilityModel const >', 'b')], 
-                   is_const=True, visibility='private', is_virtual=True)
+                   is_const=True, is_virtual=True, visibility='private')
+    return
+
+def register_Ns3ThreeGppV2vHighwayPropagationLossModel_methods(root_module, cls):
+    ## three-gpp-v2v-propagation-loss-model.h (module 'propagation'): static ns3::TypeId ns3::ThreeGppV2vHighwayPropagationLossModel::GetTypeId() [member function]
+    cls.add_method('GetTypeId', 
+                   'ns3::TypeId', 
+                   [], 
+                   is_static=True)
+    ## three-gpp-v2v-propagation-loss-model.h (module 'propagation'): ns3::ThreeGppV2vHighwayPropagationLossModel::ThreeGppV2vHighwayPropagationLossModel() [constructor]
+    cls.add_constructor([])
+    ## three-gpp-v2v-propagation-loss-model.h (module 'propagation'): double ns3::ThreeGppV2vHighwayPropagationLossModel::GetLossLos(double distance2D, double distance3D, double hUt, double hBs) const [member function]
+    cls.add_method('GetLossLos', 
+                   'double', 
+                   [param('double', 'distance2D'), param('double', 'distance3D'), param('double', 'hUt'), param('double', 'hBs')], 
+                   is_const=True, is_virtual=True, visibility='private')
     return
 
 def register_Ns3TimeValue_methods(root_module, cls):
@@ -3685,6 +3843,46 @@
                    custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
+def register_Ns3ProbabilisticV2vHighwayChannelConditionModel_methods(root_module, cls):
+    ## probabilistic-v2v-channel-condition-model.h (module 'propagation'): static ns3::TypeId ns3::ProbabilisticV2vHighwayChannelConditionModel::GetTypeId() [member function]
+    cls.add_method('GetTypeId', 
+                   'ns3::TypeId', 
+                   [], 
+                   is_static=True)
+    ## probabilistic-v2v-channel-condition-model.h (module 'propagation'): ns3::ProbabilisticV2vHighwayChannelConditionModel::ProbabilisticV2vHighwayChannelConditionModel() [constructor]
+    cls.add_constructor([])
+    ## probabilistic-v2v-channel-condition-model.h (module 'propagation'): double ns3::ProbabilisticV2vHighwayChannelConditionModel::ComputePlos(ns3::Ptr<const ns3::MobilityModel> a, ns3::Ptr<const ns3::MobilityModel> b) const [member function]
+    cls.add_method('ComputePlos', 
+                   'double', 
+                   [param('ns3::Ptr< ns3::MobilityModel const >', 'a'), param('ns3::Ptr< ns3::MobilityModel const >', 'b')], 
+                   is_const=True, is_virtual=True, visibility='private')
+    ## probabilistic-v2v-channel-condition-model.h (module 'propagation'): double ns3::ProbabilisticV2vHighwayChannelConditionModel::ComputePnlos(ns3::Ptr<const ns3::MobilityModel> a, ns3::Ptr<const ns3::MobilityModel> b) const [member function]
+    cls.add_method('ComputePnlos', 
+                   'double', 
+                   [param('ns3::Ptr< ns3::MobilityModel const >', 'a'), param('ns3::Ptr< ns3::MobilityModel const >', 'b')], 
+                   is_const=True, is_virtual=True, visibility='private')
+    return
+
+def register_Ns3ProbabilisticV2vUrbanChannelConditionModel_methods(root_module, cls):
+    ## probabilistic-v2v-channel-condition-model.h (module 'propagation'): static ns3::TypeId ns3::ProbabilisticV2vUrbanChannelConditionModel::GetTypeId() [member function]
+    cls.add_method('GetTypeId', 
+                   'ns3::TypeId', 
+                   [], 
+                   is_static=True)
+    ## probabilistic-v2v-channel-condition-model.h (module 'propagation'): ns3::ProbabilisticV2vUrbanChannelConditionModel::ProbabilisticV2vUrbanChannelConditionModel() [constructor]
+    cls.add_constructor([])
+    ## probabilistic-v2v-channel-condition-model.h (module 'propagation'): double ns3::ProbabilisticV2vUrbanChannelConditionModel::ComputePlos(ns3::Ptr<const ns3::MobilityModel> a, ns3::Ptr<const ns3::MobilityModel> b) const [member function]
+    cls.add_method('ComputePlos', 
+                   'double', 
+                   [param('ns3::Ptr< ns3::MobilityModel const >', 'a'), param('ns3::Ptr< ns3::MobilityModel const >', 'b')], 
+                   is_const=True, is_virtual=True, visibility='private')
+    ## probabilistic-v2v-channel-condition-model.h (module 'propagation'): double ns3::ProbabilisticV2vUrbanChannelConditionModel::ComputePnlos(ns3::Ptr<const ns3::MobilityModel> a, ns3::Ptr<const ns3::MobilityModel> b) const [member function]
+    cls.add_method('ComputePnlos', 
+                   'double', 
+                   [param('ns3::Ptr< ns3::MobilityModel const >', 'a'), param('ns3::Ptr< ns3::MobilityModel const >', 'b')], 
+                   is_const=True, is_virtual=True, visibility='private')
+    return
+
 def register_Ns3HashImplementation_methods(root_module, cls):
     ## hash-function.h (module 'core'): ns3::Hash::Implementation::Implementation(ns3::Hash::Implementation const & arg0) [constructor]
     cls.add_constructor([param('ns3::Hash::Implementation const &', 'arg0')])
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/propagation/model/channel-condition-model.cc ns-3.33/src/propagation/model/channel-condition-model.cc
--- ns-3.32/src/propagation/model/channel-condition-model.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/propagation/model/channel-condition-model.cc	2021-01-09 10:19:22.000000000 -0800
@@ -24,6 +24,7 @@
 #include <cmath>
 #include "ns3/node.h"
 #include "ns3/simulator.h"
+#include "ns3/string.h"
 
 namespace ns3 {
 
@@ -42,12 +43,18 @@
 }
 
 ChannelCondition::ChannelCondition ()
+  : m_losCondition (LosConditionValue::LC_ND),
+    m_o2iCondition (O2iConditionValue::O2I_ND)
+{}
+
+ChannelCondition::ChannelCondition (ChannelCondition::LosConditionValue losCondition, ChannelCondition::O2iConditionValue o2iCondition)
 {
+  m_losCondition = losCondition;
+  m_o2iCondition = o2iCondition;
 }
 
 ChannelCondition::~ChannelCondition ()
-{
-}
+{}
 
 ChannelCondition::LosConditionValue
 ChannelCondition::GetLosCondition () const
@@ -61,6 +68,78 @@
   m_losCondition = cond;
 }
 
+ChannelCondition::O2iConditionValue
+ChannelCondition::GetO2iCondition () const
+{
+  return m_o2iCondition;
+}
+
+void
+ChannelCondition::SetO2iCondition (O2iConditionValue o2iCondition)
+{
+  m_o2iCondition = o2iCondition;
+}
+
+bool
+ChannelCondition::IsLos () const
+{
+  return (m_losCondition == ChannelCondition::LOS);
+}
+
+bool
+ChannelCondition::IsNlos () const
+{
+  return (m_losCondition == ChannelCondition::NLOS);
+}
+
+bool
+ChannelCondition::IsNlosv () const
+{
+  return (m_losCondition == ChannelCondition::NLOSv);
+}
+
+bool
+ChannelCondition::IsO2i () const
+{
+  return (m_o2iCondition == ChannelCondition::O2I);
+}
+
+bool
+ChannelCondition::IsO2o () const
+{
+  return (m_o2iCondition == ChannelCondition::O2O);
+}
+
+bool
+ChannelCondition::IsI2i () const
+{
+  return (m_o2iCondition == ChannelCondition::I2I);
+}
+
+bool
+ChannelCondition::IsEqual (Ptr<const ChannelCondition> otherCondition) const
+{
+  return (m_o2iCondition == otherCondition->GetO2iCondition ()
+          && m_losCondition == otherCondition->GetLosCondition ());
+}
+
+std::ostream& operator<< (std::ostream& os, ChannelCondition::LosConditionValue cond)
+{
+  if (cond == ChannelCondition::LosConditionValue::LOS)
+    {
+      os << "LOS";
+    }
+  else if (cond == ChannelCondition::LosConditionValue::NLOS)
+    {
+      os << "NLOS";
+    }
+  else if (cond == ChannelCondition::LosConditionValue::NLOSv)
+    {
+      os << "NLOSv";
+    }
+
+  return os;
+}
 // ------------------------------------------------------------------------- //
 
 NS_OBJECT_ENSURE_REGISTERED (ChannelConditionModel);
@@ -76,12 +155,10 @@
 }
 
 ChannelConditionModel::ChannelConditionModel ()
-{
-}
+{}
 
 ChannelConditionModel::~ChannelConditionModel ()
-{
-}
+{}
 
 // ------------------------------------------------------------------------- //
 
@@ -99,12 +176,10 @@
 }
 
 AlwaysLosChannelConditionModel::AlwaysLosChannelConditionModel ()
-{
-}
+{}
 
 AlwaysLosChannelConditionModel::~AlwaysLosChannelConditionModel ()
-{
-}
+{}
 
 Ptr<ChannelCondition>
 AlwaysLosChannelConditionModel::GetChannelCondition (Ptr<const MobilityModel> a,
@@ -113,8 +188,7 @@
   NS_UNUSED (a);
   NS_UNUSED (b);
 
-  Ptr<ChannelCondition> c = CreateObject<ChannelCondition> ();
-  c->SetLosCondition (ChannelCondition::LOS);
+  Ptr<ChannelCondition> c = CreateObject<ChannelCondition> (ChannelCondition::LOS);
 
   return c;
 }
@@ -141,12 +215,10 @@
 }
 
 NeverLosChannelConditionModel::NeverLosChannelConditionModel ()
-{
-}
+{}
 
 NeverLosChannelConditionModel::~NeverLosChannelConditionModel ()
-{
-}
+{}
 
 Ptr<ChannelCondition>
 NeverLosChannelConditionModel::GetChannelCondition (Ptr<const MobilityModel> a,
@@ -155,8 +227,7 @@
   NS_UNUSED (a);
   NS_UNUSED (b);
 
-  Ptr<ChannelCondition> c = CreateObject<ChannelCondition> ();
-  c->SetLosCondition (ChannelCondition::NLOS);
+  Ptr<ChannelCondition> c = CreateObject<ChannelCondition> (ChannelCondition::NLOS);
 
   return c;
 }
@@ -169,6 +240,43 @@
 
 // ------------------------------------------------------------------------- //
 
+NS_OBJECT_ENSURE_REGISTERED (NeverLosVehicleChannelConditionModel);
+
+TypeId
+NeverLosVehicleChannelConditionModel::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::NeverLosVehicleChannelConditionModel")
+    .SetParent<ChannelConditionModel> ()
+    .SetGroupName ("Propagation")
+    .AddConstructor<NeverLosVehicleChannelConditionModel> ()
+  ;
+  return tid;
+}
+
+NeverLosVehicleChannelConditionModel::NeverLosVehicleChannelConditionModel ()
+{}
+
+NeverLosVehicleChannelConditionModel::~NeverLosVehicleChannelConditionModel ()
+{}
+
+Ptr<ChannelCondition>
+NeverLosVehicleChannelConditionModel::GetChannelCondition (Ptr<const MobilityModel> /* a */,
+                                                           Ptr<const MobilityModel> /* b */) const
+{
+
+  Ptr<ChannelCondition> c = CreateObject<ChannelCondition> (ChannelCondition::NLOSv);
+
+  return c;
+}
+
+int64_t
+NeverLosVehicleChannelConditionModel::AssignStreams (int64_t /* stream */)
+{
+  return 0;
+}
+
+// ------------------------------------------------------------------------- //
+
 NS_OBJECT_ENSURE_REGISTERED (ThreeGppChannelConditionModel);
 
 TypeId
@@ -194,8 +302,7 @@
 }
 
 ThreeGppChannelConditionModel::~ThreeGppChannelConditionModel ()
-{
-}
+{}
 
 void ThreeGppChannelConditionModel::DoDispose ()
 {
@@ -239,38 +346,63 @@
   // generate a new channel condition
   if (notFound || update)
     {
-      // compute the LOS probability (see 3GPP TR 38.901, Sec. 7.4.2)
-      double pLos = ComputePlos (a, b);
+      cond = ComputeChannelCondition (a, b);
+      // store the channel condition in m_channelConditionMap, used as cache.
+      // For this reason you see a const_cast.
+      Item mapItem;
+      mapItem.m_condition = cond;
+      mapItem.m_generatedTime = Simulator::Now ();
+      const_cast<ThreeGppChannelConditionModel*> (this)->m_channelConditionMap [key] = mapItem;
+    }
 
-      // draw a random value
-      double pRef = m_uniformVar->GetValue ();
+  return cond;
+}
 
-      // get the channel condition
-      cond = CreateObject<ChannelCondition> ();
-      if (pRef <= pLos)
-        {
-          // LOS
-          cond->SetLosCondition (ChannelCondition::LosConditionValue::LOS);
-        }
-      else
-        {
-          // NLOS
-          cond->SetLosCondition (ChannelCondition::LosConditionValue::NLOS);
-        }
+Ptr<ChannelCondition>
+ThreeGppChannelConditionModel::ComputeChannelCondition (Ptr<const MobilityModel> a,
+                                                        Ptr<const MobilityModel> b) const
+{
+  NS_LOG_FUNCTION (this << a << b);
+  Ptr<ChannelCondition> cond = CreateObject<ChannelCondition> ();
+
+  // compute the LOS probability
+  double pLos = ComputePlos (a, b);
+  double pNlos = ComputePnlos (a, b);
+
+  // draw a random value
+  double pRef = m_uniformVar->GetValue ();
+
+  NS_LOG_DEBUG ("pRef " << pRef << " pLos " << pLos << " pNlos " << pNlos);
 
-      {
-        // store the channel condition in m_channelConditionMap, used as cache.
-        // For this reason you see a const_cast.
-        Item mapItem;
-        mapItem.m_condition = cond;
-        mapItem.m_generatedTime = Simulator::Now ();
-        const_cast<ThreeGppChannelConditionModel*> (this)->m_channelConditionMap [key] = mapItem;
-      }
+  // get the channel condition
+  if (pRef <= pLos)
+    {
+      // LOS
+      cond->SetLosCondition (ChannelCondition::LosConditionValue::LOS);
+    }
+  else if (pRef <= pLos + pNlos)
+    {
+      // NLOS
+      cond->SetLosCondition (ChannelCondition::LosConditionValue::NLOS);
+    }
+  else
+    {
+      // NLOSv (added to support vehicular scenarios)
+      cond->SetLosCondition (ChannelCondition::LosConditionValue::NLOSv);
     }
 
   return cond;
 }
 
+double
+ThreeGppChannelConditionModel::ComputePnlos (Ptr<const MobilityModel> a,
+                                             Ptr<const MobilityModel> b) const
+{
+  NS_LOG_FUNCTION (this << a << b);
+  // by default returns 1 - PLOS
+  return (1 - ComputePlos (a, b));
+}
+
 int64_t
 ThreeGppChannelConditionModel::AssignStreams (int64_t stream)
 {
@@ -319,12 +451,10 @@
 
 ThreeGppRmaChannelConditionModel::ThreeGppRmaChannelConditionModel ()
   : ThreeGppChannelConditionModel ()
-{
-}
+{}
 
 ThreeGppRmaChannelConditionModel::~ThreeGppRmaChannelConditionModel ()
-{
-}
+{}
 
 double
 ThreeGppRmaChannelConditionModel::ComputePlos (Ptr<const MobilityModel> a,
@@ -367,12 +497,10 @@
 
 ThreeGppUmaChannelConditionModel::ThreeGppUmaChannelConditionModel ()
   : ThreeGppChannelConditionModel ()
-{
-}
+{}
 
 ThreeGppUmaChannelConditionModel::~ThreeGppUmaChannelConditionModel ()
-{
-}
+{}
 
 double
 ThreeGppUmaChannelConditionModel::ComputePlos (Ptr<const MobilityModel> a,
@@ -437,12 +565,10 @@
 
 ThreeGppUmiStreetCanyonChannelConditionModel::ThreeGppUmiStreetCanyonChannelConditionModel ()
   : ThreeGppChannelConditionModel ()
-{
-}
+{}
 
 ThreeGppUmiStreetCanyonChannelConditionModel::~ThreeGppUmiStreetCanyonChannelConditionModel ()
-{
-}
+{}
 
 double
 ThreeGppUmiStreetCanyonChannelConditionModel::ComputePlos (Ptr<const MobilityModel> a,
@@ -492,12 +618,10 @@
 
 ThreeGppIndoorMixedOfficeChannelConditionModel::ThreeGppIndoorMixedOfficeChannelConditionModel ()
   : ThreeGppChannelConditionModel ()
-{
-}
+{}
 
 ThreeGppIndoorMixedOfficeChannelConditionModel::~ThreeGppIndoorMixedOfficeChannelConditionModel ()
-{
-}
+{}
 
 double
 ThreeGppIndoorMixedOfficeChannelConditionModel::ComputePlos (Ptr<const MobilityModel> a,
@@ -551,12 +675,10 @@
 
 ThreeGppIndoorOpenOfficeChannelConditionModel::ThreeGppIndoorOpenOfficeChannelConditionModel ()
   : ThreeGppChannelConditionModel ()
-{
-}
+{}
 
 ThreeGppIndoorOpenOfficeChannelConditionModel::~ThreeGppIndoorOpenOfficeChannelConditionModel ()
-{
-}
+{}
 
 double
 ThreeGppIndoorOpenOfficeChannelConditionModel::ComputePlos (Ptr<const MobilityModel> a,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/propagation/model/channel-condition-model.h ns-3.33/src/propagation/model/channel-condition-model.h
--- ns-3.32/src/propagation/model/channel-condition-model.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/propagation/model/channel-condition-model.h	2021-01-09 10:19:22.000000000 -0800
@@ -48,7 +48,20 @@
   enum LosConditionValue
   {
     LOS, //!< Line of Sight
-    NLOS //!< Non Line of Sight
+    NLOS, //!< Non Line of Sight
+    NLOSv, //!< Non Line of Sight due to a vehicle
+    LC_ND //!< Los condition not defined
+  };
+  
+  /**
+   * Possible values for Outdoor to Indoor condition.
+   */
+  enum O2iConditionValue
+  {
+    O2O, //!< Outdoor to Outdoor
+    O2I, //!< Outdoor to Indoor
+    I2I, //!< Indoor to Indoor
+    O2I_ND //!< Outdoor to Indoor condition not defined
   };
 
   /**
@@ -62,6 +75,13 @@
    * Constructor for the ChannelCondition class
    */
   ChannelCondition ();
+  
+  /**
+   * Constructor for the ChannelCondition class
+   * \param losCondition the LOS condition value
+   * \param o2iCondition the O2I condition value (by default is set to O2O)
+   */
+  ChannelCondition (LosConditionValue losCondition, O2iConditionValue o2iCondition = O2O);
 
   /**
    * Destructor for the ChannelCondition class
@@ -83,9 +103,89 @@
    * \param the LosConditionValue
    */
   void SetLosCondition (LosConditionValue losCondition);
+  
+  /**
+   * Get the O2iConditionValue contaning the information about the O2I
+   * state of the channel
+   *
+   * \return the O2iConditionValue
+   */
+  O2iConditionValue GetO2iCondition () const;
+
+  /**
+   * Set the O2iConditionValue contaning the information about the O2I
+   * state of the channel
+   *
+   * \param o2iCondition the O2iConditionValue
+   */
+  void SetO2iCondition (O2iConditionValue o2iCondition);
+  
+  /**
+   * Return true if the channel condition is LOS
+   *
+   * \return true if the channel condition is LOS
+   */
+  bool IsLos () const;
+  
+  /**
+   * Return true if the channel condition is NLOS
+   *
+   * It does not consider the case in which the LOS path is obstructed by a 
+   * vehicle. This case is represented as a separate channel condition (NLOSv), 
+   * use the method IsNlosv instead.
+   *
+   * \return true if the channel condition is NLOS
+   */
+  bool IsNlos () const;
+  
+  /**
+   * Return true if the channel condition is NLOSv
+   *
+   * \return true if the channel condition is NLOSv
+   */
+  bool IsNlosv () const;
+  
+  /**
+   * Return true if the channel is outdoor-to-indoor
+   *
+   * \return true if the channel is outdoor-to-indoor
+   */
+  bool IsO2i () const;
+  
+  /**
+   * Return true if the channel is outdoor-to-outdoor
+   *
+   * \return true if the channel is outdoor-to-outdoor
+   */
+  bool IsO2o () const;
+  
+  /**
+   * Return true if the channel is indoor-to-indoor
+   *
+   * \return true if the channel is indoor-to-indoor
+   */
+  bool IsI2i () const;
+  
+  /**
+   * Return true if this instance is equivalent to the one passed as argument
+   *
+   * \param otherCondition the other instance to compare with this instance
+   * \return true if this instance is equivalent to the one passed as argument
+   */
+  bool IsEqual (Ptr<const ChannelCondition> otherCondition) const;
 
 private:
-  LosConditionValue m_losCondition; //!< contains the information about the LOS/NLOS state of the channel
+  LosConditionValue m_losCondition; //!< contains the information about the LOS state of the channel
+  O2iConditionValue m_o2iCondition; //!< contains the information about the O2I state of the channel
+  
+  /** 
+   * Prints a LosConditionValue to output
+   * \param os the output stream
+   * \param cond the LosConditionValue
+   * 
+   * \return a reference to the output stream
+   */
+  friend std::ostream& operator<< (std::ostream& os, LosConditionValue cond);
 
 };
 
@@ -133,7 +233,7 @@
    * 'stream'. Return the number of streams (possibly zero) that
    * have been assigned.
    *
-   * \param stream
+   * \param stream the offset used to set the stream numbers
    * \return the number of stream indices assigned by this model
    */
   virtual int64_t AssignStreams (int64_t stream) = 0;
@@ -170,12 +270,12 @@
   static TypeId GetTypeId (void);
 
   /**
-   * Constructor for the ChannelConditionModel class
+   * Constructor
    */
   AlwaysLosChannelConditionModel ();
 
   /**
-   * Destructor for the ChannelConditionModel class
+   * Destructor
    */
   virtual ~AlwaysLosChannelConditionModel ();
 
@@ -199,7 +299,7 @@
   * \brief Copy constructor
   *
   * Defined and unimplemented to avoid misuse
-  * \returns
+  * \returns a copy of the object
   */
   AlwaysLosChannelConditionModel &operator = (const AlwaysLosChannelConditionModel &) = delete;
 
@@ -209,7 +309,7 @@
    * 'stream'. Return the number of streams (possibly zero) that
    * have been assigned.
    *
-   * \param stream
+   * \param stream the offset used to set the stream numbers
    * \return the number of stream indices assigned by this model
    */
   virtual int64_t AssignStreams (int64_t stream) override;
@@ -231,12 +331,12 @@
   static TypeId GetTypeId (void);
 
   /**
-   * Constructor for the ChannelConditionModel class
+   * Constructor
    */
   NeverLosChannelConditionModel ();
 
   /**
-   * Destructor for the ChannelConditionModel class
+   * Destructor
    */
   virtual ~NeverLosChannelConditionModel ();
 
@@ -260,7 +360,7 @@
   * \brief Copy constructor
   *
   * Defined and unimplemented to avoid misuse
-  * \returns
+  * \returns a copy of the object
   */
   NeverLosChannelConditionModel &operator = (const NeverLosChannelConditionModel &) = delete;
 
@@ -270,7 +370,68 @@
    * 'stream'. Return the number of streams (possibly zero) that
    * have been assigned.
    *
-   * \param stream
+   * \param stream the offset used to set the stream numbers
+   * \return the number of stream indices assigned by this model
+   */
+  virtual int64_t AssignStreams (int64_t stream) override;
+};
+
+/**
+ * \ingroup propagation
+ *
+ * \brief Models a never in-LoS condition model caused by a blocking vehicle
+ */
+class NeverLosVehicleChannelConditionModel : public ChannelConditionModel
+{
+public:
+  /**
+   * Get the type ID.
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+
+  /**
+   * Constructor 
+   */
+  NeverLosVehicleChannelConditionModel ();
+
+  /**
+   * Destructor 
+   */
+  virtual ~NeverLosVehicleChannelConditionModel ();
+
+  /**
+   * Computes the condition of the channel between a and b, that will be always NLOSv
+   *
+   * \param a mobility model
+   * \param b mobility model
+   * \return the condition of the channel between a and b, that will be always NLOSv
+   */
+  virtual Ptr<ChannelCondition> GetChannelCondition (Ptr<const MobilityModel> a, Ptr<const MobilityModel> b) const override;
+
+  /**
+  * \brief Copy constructor
+  *
+  * Defined and unimplemented to avoid misuse
+  */
+  NeverLosVehicleChannelConditionModel (const NeverLosVehicleChannelConditionModel&) = delete;
+
+  /**
+  * \brief Copy constructor
+  *
+  * Defined and unimplemented to avoid misuse
+  * \returns a copy of the object
+  */
+  NeverLosVehicleChannelConditionModel &operator = (const NeverLosVehicleChannelConditionModel &) = delete;
+
+  /**
+   * If this  model uses objects of type RandomVariableStream,
+   * set the stream numbers to the integers starting with the offset
+   * 'stream'. Return the number of streams (possibly zero) that
+   * have been assigned.
+   *
+   * \param stream the offset used to set the stream numbers
    * \return the number of stream indices assigned by this model
    */
   virtual int64_t AssignStreams (int64_t stream) override;
@@ -305,9 +466,9 @@
   /**
    * \brief Retrieve the condition of the channel between a and b.
    *
-   * If the channel condition does not exists, the method creates it and
-   * store it in a local cache, that will be updated following the "UpdatePeriod"
-   * parameter.
+   * If the channel condition does not exists, the method computes it by calling 
+   * ComputeChannelCondition and stores it in a local cache, that will be updated 
+   * following the "UpdatePeriod" parameter.
    *
    * \param a mobility model
    * \param b mobility model
@@ -321,7 +482,7 @@
    * 'stream'. Return the number of streams (possibly zero) that
    * have been assigned.
    *
-   * \param stream
+   * \param stream the offset used to set the stream numbers
    * \return the number of stream indices assigned by this model
    */
   virtual int64_t AssignStreams (int64_t stream) override;
@@ -330,22 +491,54 @@
   virtual void DoDispose () override;
   
   /**
+   * Determine the density of vehicles in a V2V scenario.
+   */
+  enum VehicleDensity
+  {
+    LOW,
+    MEDIUM,
+    HIGH,
+    INVALID
+  };
+
+  /**
   * \brief Computes the 2D distance between two 3D vectors
   * \param a the first 3D vector
   * \param b the second 3D vector
   * \return the 2D distance between a and b
   */
   static double Calculate2dDistance (const Vector &a, const Vector &b);
+  
+  Ptr<UniformRandomVariable> m_uniformVar; //!< uniform random variable
 
 private:
   /**
-   * Compute the LOS probability as specified in Table 7.4.2-1 of 3GPP TR 38.901.
+  * This method computes the channel condition based on a probabilistic model 
+  * that is specific for the scenario of interest
+  *
+  * \param a tx mobility model
+  * \param b rx mobility model
+  * \return the channel condition
+  */
+  Ptr<ChannelCondition> ComputeChannelCondition (Ptr<const MobilityModel> a, Ptr<const MobilityModel> b) const;
+  
+  /**
+   * Compute the LOS probability.
    *
    * \param a tx mobility model
    * \param b rx mobility model
    * \return the LOS probability
    */
   virtual double ComputePlos (Ptr<const MobilityModel> a, Ptr<const MobilityModel> b) const = 0;
+  
+  /**
+   * Compute the NLOS probability. By default returns 1 - PLOS
+   *
+   * \param a tx mobility model
+   * \param b rx mobility model
+   * \return the LOS probability
+   */
+  virtual double ComputePnlos (Ptr<const MobilityModel> a, Ptr<const MobilityModel> b) const;
 
   /**
    * \brief Returns a unique and reciprocal key for the channel between a and b.
@@ -366,7 +559,6 @@
 
   std::unordered_map<uint32_t, Item> m_channelConditionMap; //!< map to store the channel conditions
   Time m_updatePeriod; //!< the update period for the channel condition
-  Ptr<UniformRandomVariable> m_uniformVar; //!< uniform random variable
 };
 
 /**
